#! /usr/bin/env python
# -*- coding: utf-8 -*-

import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os

    
class MyDocument(QTextDocument):
    '''
    The text model
    @arg parent: The parent should be the CodeEditor
    '''
    # We'll stick to QFile instead of the lovely simplicity of Python file
    def __init__(self, parent, url = None):
        data = ''
        QTextDocument.__init__(self, parent)
        if url and QFile.exists(url.path()):
            self.__file = QFile(url.path())
            self.__file.open(QIODevice.Text | QIODevice.ReadWrite)
            data = self.__file.read(self.__file.size())
            if not data:
                QMessageBox.information(self, "%s" % url ,
                                        "No data could be read from %s" % url)
            # Convert data from QByteArray to QString
            data = QString(data)
            # Document data
            print "Settings text data"
            self.setPlainText(data)
            print "Settings title data"
            # Document tiltle
            title = self.__file.fileName().split(os.sep).last()
            print title
            print "Seting title..."
            self.setMetaInformation(QTextDocument.DocumentTitle, title)
            print "title set"

app = QApplication([])
win = QMainWindow()
texteditor = QTextEdit()
url = QUrl()
url.setScheme('file')
url.setPath(__file__)
print url
win.setCentralWidget(texteditor)
doc = MyDocument(texteditor, url)
texteditor.setDocument(doc)
win.show()
sys.exit(app.exec_())